# Class VulkanExtensionProperties

java.lang.Object
com.io7m.jcoronado.api.VulkanExtensionProperties

All Implemented Interfaces:
  `VulkanExtensionPropertiesType`

public final class VulkanExtensionProperties extends Object implements VulkanExtensionPropertiesType
An extension.

See Also:
  - "VkExtensionProperties"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanExtensionProperties.Builder`
  Builds instances of type `VulkanExtensionProperties`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanExtensionProperties.Builder`
  `builder()`
  Creates a builder for `VulkanExtensionProperties`.
  `static VulkanExtensionProperties`
  `copyOf(VulkanExtensionPropertiesType instance)`
  Creates an immutable copy of a `VulkanExtensionPropertiesType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanExtensionProperties` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `name`, `version`.
  `String`
  `name()`
  `String`
  `toString()`
  Prints the immutable value `VulkanExtensionProperties` with attribute values.
  `int`
  `version()`
  `final VulkanExtensionProperties`
  `withName(String value)`
  Copy the current immutable object by setting a value for the `name` attribute.
  `final VulkanExtensionProperties`
  `withVersion(int value)`
  Copy the current immutable object by setting a value for the `version` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### name

    public String name()
    Specified by:
      `name` in interface `VulkanExtensionPropertiesType`
    Returns:
      The name of the extension

  - ### version

    public int version()
    Specified by:
      `version` in interface `VulkanExtensionPropertiesType`
    Returns:
      The version of the extension

  - ### withName

    public final VulkanExtensionProperties withName(String value)
    Copy the current immutable object by setting a value for the `name` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for name
    Returns:
      A modified copy or the `this` object

  - ### withVersion

    public final VulkanExtensionProperties withVersion(int value)
    Copy the current immutable object by setting a value for the `version` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for version
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanExtensionProperties` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `name`, `version`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanExtensionProperties` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanExtensionProperties copyOf(VulkanExtensionPropertiesType instance)
    Creates an immutable copy of a `VulkanExtensionPropertiesType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanExtensionProperties instance

  - ### builder

    public static VulkanExtensionProperties.Builder builder()
    Creates a builder for `VulkanExtensionProperties`.

        VulkanExtensionProperties.builder()
           .setName(String) // required name
           .setVersion(int) // required version
           .build();

    Returns:
      A new VulkanExtensionProperties builder